/*
*    Infinity Loader :: Created By AgreedBog381 && SyGnUs Legends
*
*    Project : Synergy V3
*    Author : MrFawkes1337
*    Game : Call of Duty: Black Ops 3
*    Description : GSC Container for The Claw
*    Date : 25/12/2020 22:07:21
*
*/


Build_TheClaw()
{
    if (level.BuildSpaceFull == 1)
    {
        self S("[^1ERROR]^4You Already have a Spawnable in place.");
    }
    else
    {
            self thread Build_TheClaw2();
            self S("Spawning The Claw");
            level.BuildSpaceFull = 1;
            level.TheClawSpawned = true;
    }
}

Build_TheClaw2()
{
    level endon( "Destroy_Claw" );
    level.claworg   = self.origin;
    pos             = ( 0, 15, 460 );
    level.clawseats = [];
    level.claw      = [];
    level.legs      = [];
    level.attach    = modelSpawner( level.claworg + ( 0, 55, 60 ), "tag_origin" );
    level.clawlink  = modelSpawner( pos, "tag_origin" );
    e               = 0;
    while( e < 2 )
    {
        a = 0;
        while( a < 8 )
        {
            level.legs[level.legs.size] = modelSpawner( level.claworg + ( ( -220, -145 + e * 320, 0 ) + ( a * 28, 0, a * 60 ) ), "wpn_t7_care_package_world", ( 25, 0, 90 ), 0.1 );
            a++;
        }
        e++;
    }
    e = 0;
    while( e < 2 )
    {
        a = 0;
        while( a < 8 )
        {
            level.legs[level.legs.size] = modelSpawner( level.claworg + ( ( 220, -145 + e * 320, 0 ) + ( a * -28, 0, a * 60 ) ), "wpn_t7_care_package_world", ( -25, 0, 90 ), 0.1 );
            a++;
        }
        e++;
    }
    a = 0;
    while( a < 5 )
    {
        e = 0;
        while( e < 8 )
        {
            level.claw[level.claw.size] = modelSpawner( level.claworg + ( ( 0, -125 + a * 70, 460 ) + ( sin( -90 + e * 45 ) * 25, 0, sin( e * 45 ) * 25 ) ), "wpn_t7_care_package_world", ( e * 45, 180, 0 ), 0.1 );
            e++;
        }
        a++;
    }
    a = 0;
    while( a < 8 )
    {
        e = 0;
        while( e < 6 )
        {
            level.claw[level.claw.size] = modelSpawner( level.claworg + ( ( 0, 15, 460 ) + ( cos( a * 45 ) * 30, sin( a * 45 ) * 30, e * -70 ) ), "wpn_t7_care_package_world", ( 0, a * 45 + 90, 90 ), 0.1 );
            e++;
        }
        a++;
    }
    level.claw[level.claw.size] = modelSpawner( level.claworg + ( 0, 15, 60 ), "wpn_t7_care_package_world", ( 0, 90, 90 ), 0.1 );
    a = 0;
    while( a < 2 )
    {
        e = 0;
        while( e < 12 )
        {
            level.claw[level.claw.size] = modelSpawner( level.claworg + ( ( 0, 15, 100 ) + ( cos( e * 30 ) * ( 40 + ( a * 55 ) ), sin( e * 30 ) * ( 40 + ( a * 55 ) ), -70 ) ), "wpn_t7_care_package_world", ( 0, e * 30 + ( -90 + a * 90 ), 0 ), 0.1 );
            e++;
        }
        a++;
    }
    e = 0;
    while( e < 12 )
    {
        level.clawseats[level.clawseats.size] = modelSpawner( level.claworg + ( ( 0, 15, 95 ) + ( cos( e * 30 ) * 95, sin( e * 30 ) * 95, -60 ) ), "tag_origin", undefined, 0.1 );
        e++;
    }
    foreach( model in level.claw )
    {
        model linkto( level.clawlink );
    }
    foreach( model in level.clawseats )
    {
        model linkto( level.clawlink );
    }
    level.clawlink thread ClawMovements();
    level.attach thread monitorseatsystem( level.clawseats, "Claw", 200, 30, "The Claw", "Claw", "Destroy_Claw" );

}


ClawMovements()
{

    level endon("Destroy_Claw");

    for(a=0;a>=-40;a-=2)

    {

        self rotateTo((a,self.angles[1],0),.5);

        wait .1;

    }

    for(a=a;a<=60;a+=3)

    {

        self rotateTo((a,self.angles[1],0),.5);

        wait .1;

    }

    for(a=a;a>=-80;a-=3)

    {

        self rotateTo((a,self.angles[1],0),.5);

        wait .05;

    }

    for(a=a;a<=100;a+=4)

    {

        self rotateTo((a,self.angles[1],0),.5);

        wait .05;

    }

    while(true)

    {

        for(a=a;a>=-105;a-=5)

        {

            self rotateTo((a,self.angles[1],0),.5);

            wait .05;

        }

        for(a=a;a<=105;a+=5)

        {

            self rotateTo((a,self.angles[1],0),.5);

            wait .05;

        }

        wait .05;

    }

}

PlayerRideAngles(i)
{
    level endon("Destroy_Claw");
    while (isDefined(i.riding))
    {
        for(a=0;a>=-40;a-=2)

    {

        i rotateTo((a,self.angles[1],0),.5);

        wait .1;

    }

    for(a=a;a<=60;a+=3)

    {

        i rotateTo((a,self.angles[1],0),.5);

        wait .1;

    }

    for(a=a;a>=-80;a-=3)

    {

        i rotateTo((a,self.angles[1],0),.5);

        wait .05;

    }

    for(a=a;a<=100;a+=4)

    {

        i rotateTo((a,self.angles[1],0),.5);

        wait .05;

    }

    while(true)

    {

        for(a=a;a>=-105;a-=5)

        {

            i rotateTo((a,self.angles[1],0),.5);

            wait .05;

        }

        for(a=a;a<=105;a+=5)

        {

            i rotateTo((a,self.angles[1],0),.5);

            wait .05;

        }

        wait .05;

    }
}
}

